﻿# The script of the game goes into this file.

init python:
    def get_inv(inv):
        out = ""
        for i in inv:
            out += f"{i.name}, "
        return out

    class Equipment:

        def __init__(self, name="None", attr="", stats=0):
            self.name = name
            self.attr = attr
            self.stats = stats

        def show(self):
            return f"{self.name}, +{self.stats} {self.attr}"

    class Mecha:
        def __init__(self):
            self.arm = Equipment()
            self.leg = Equipment()
            self.core = Equipment()

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define s = Character("Suzette", color="#769e5f")
default inventory = []
default mechS = Mecha()
default rings = 10000

# The game starts here:

label start:

    scene bg room:
        truecenter
        zoom 0.4
    with dissolve

    s "I may have lost that duel, but Red better watch out cause the MechaSuzzete MK3 will be even better."

    menu:
        "Gotta get some better parts":
            call shop from _call_shop

        "Challenge Red immediately":
            s "Capitalism is overrated anyways."
    s "Time to challenge Red to another Duel"

    "Currently Equipped:"
    $ renpy.say(None, f'arm: {mechS.arm.show()}\ncore: {mechS.core.show()}\nleg: {mechS.leg.show()}')
    return

label shop:
    s "Now let's see, which parts should I buy."
label .buy:
    $ s(f"I currently have {rings} rings.")
    menu:
        "armour - 1000 rings":
            $ rings -= 1000
            s "Armour accquired!"
            $ inventory.append(Equipment("armour", "def", 5))
            jump .buy
        "hydraulics 2 - 4000 rings":
            $ rings -= 4000
            s "4000?! What a ripoff."
            $ inventory.append(Equipment("hydraulics 2", "hyd", 10))
            jump .buy
        "done":
            s "alright, there goes all my hard earned rings"

    s "Time to finish MechaSuzette MK3"
    if len(inventory) == 0:
        s "Oh wait, I didn't buy anything. Let's just get right to the duel."
        return
label .equip:
    $ renpy.say(None, f'Inventory: {get_inv(inventory)}\narm: {mechS.arm.show()}\ncore: {mechS.core.show()}\nleg: {mechS.leg.show()}')
    menu:
        "arm":
            python:
                renpy.say(None, f'Currently Equipped: {mechS.arm.show()}')
                result = renpy.display_menu([(i.show(), i) for i in inventory])
                if mechS.arm.name != "None":
                    inventory.append(mechS.arm)
                mechS.arm = result
                inventory.remove(result)
            jump .equip
        "core":
            python:
                renpy.say(None, f'Currently Equipped: {mechS.core.show()}')
                result = renpy.display_menu([(i.show(), i) for i in inventory])
                if mechS.core.name != "None":
                    inventory.append(mechS.core)
                mechS.core = result
                inventory.remove(result)
            jump .equip
        "leg":
            python:
                renpy.say(None, f'Currently Equipped: {mechS.leg.show()}')
                result = renpy.display_menu([(i.show(), i) for i in inventory])
                if mechS.leg.name != "None":
                    inventory.append(mechS.leg)
                mechS.leg = result
                inventory.remove(result)
            jump .equip
        "done":
            s "MechaSuzette MK3 is now complete!"
    return
